/*
 * Copyright (C) 2003 Jeppe Nejsum Madsen, nejsum@diku.dk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "stdafx.h"
#include <sstream>
#include "formatter.hpp"

//#define RET return;
#define RET 

Formatter::Formatter(const std::string &str, std::ostream &s)
: stream(s), lastchars(0)
  {
  RET;
  s << str << " ";
  }

Formatter::~Formatter()
  {
  RET;
  stream << "\n";
  }

void Formatter::writeString(const std::string &str)
  {
  RET;
  std::string  bs(lastchars, '\b');
  lastchars = str.size();
  stream << bs << str << std::flush;
  }

void Formatter::writeProgress(int cur, int max)
  {
  RET;
  std::stringstream s;
  s << cur << "/" << max;
  writeString(s.str());
  }

void Formatter::writeProgress(int cur, int max, size_t n)
  {
  RET;
  std::stringstream s;
  s << cur << "/" << max << " (" << n << ")";
  writeString(s.str());
  }
