/*
 * Copyright (C) 2003 Jeppe Nejsum Madsen, nejsum@diku.dk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef NEWBITSET_H
#define NEWBITSET_H

const unsigned char bit_count[] = {
      0, /*   0 */ 1, /*   1 */ 1, /*   2 */ 2, /*   3 */ 1, /*   4 */
      2, /*   5 */ 2, /*   6 */ 3, /*   7 */ 1, /*   8 */ 2, /*   9 */
      2, /*  10 */ 3, /*  11 */ 2, /*  12 */ 3, /*  13 */ 3, /*  14 */
      4, /*  15 */ 1, /*  16 */ 2, /*  17 */ 2, /*  18 */ 3, /*  19 */
      2, /*  20 */ 3, /*  21 */ 3, /*  22 */ 4, /*  23 */ 2, /*  24 */
      3, /*  25 */ 3, /*  26 */ 4, /*  27 */ 3, /*  28 */ 4, /*  29 */
      4, /*  30 */ 5, /*  31 */ 1, /*  32 */ 2, /*  33 */ 2, /*  34 */
      3, /*  35 */ 2, /*  36 */ 3, /*  37 */ 3, /*  38 */ 4, /*  39 */
      2, /*  40 */ 3, /*  41 */ 3, /*  42 */ 4, /*  43 */ 3, /*  44 */
      4, /*  45 */ 4, /*  46 */ 5, /*  47 */ 2, /*  48 */ 3, /*  49 */
      3, /*  50 */ 4, /*  51 */ 3, /*  52 */ 4, /*  53 */ 4, /*  54 */
      5, /*  55 */ 3, /*  56 */ 4, /*  57 */ 4, /*  58 */ 5, /*  59 */
      4, /*  60 */ 5, /*  61 */ 5, /*  62 */ 6, /*  63 */ 1, /*  64 */
      2, /*  65 */ 2, /*  66 */ 3, /*  67 */ 2, /*  68 */ 3, /*  69 */
      3, /*  70 */ 4, /*  71 */ 2, /*  72 */ 3, /*  73 */ 3, /*  74 */
      4, /*  75 */ 3, /*  76 */ 4, /*  77 */ 4, /*  78 */ 5, /*  79 */
      2, /*  80 */ 3, /*  81 */ 3, /*  82 */ 4, /*  83 */ 3, /*  84 */
      4, /*  85 */ 4, /*  86 */ 5, /*  87 */ 3, /*  88 */ 4, /*  89 */
      4, /*  90 */ 5, /*  91 */ 4, /*  92 */ 5, /*  93 */ 5, /*  94 */
      6, /*  95 */ 2, /*  96 */ 3, /*  97 */ 3, /*  98 */ 4, /*  99 */
      3, /* 100 */ 4, /* 101 */ 4, /* 102 */ 5, /* 103 */ 3, /* 104 */
      4, /* 105 */ 4, /* 106 */ 5, /* 107 */ 4, /* 108 */ 5, /* 109 */
      5, /* 110 */ 6, /* 111 */ 3, /* 112 */ 4, /* 113 */ 4, /* 114 */
      5, /* 115 */ 4, /* 116 */ 5, /* 117 */ 5, /* 118 */ 6, /* 119 */
      4, /* 120 */ 5, /* 121 */ 5, /* 122 */ 6, /* 123 */ 5, /* 124 */
      6, /* 125 */ 6, /* 126 */ 7, /* 127 */ 1, /* 128 */ 2, /* 129 */
      2, /* 130 */ 3, /* 131 */ 2, /* 132 */ 3, /* 133 */ 3, /* 134 */
      4, /* 135 */ 2, /* 136 */ 3, /* 137 */ 3, /* 138 */ 4, /* 139 */
      3, /* 140 */ 4, /* 141 */ 4, /* 142 */ 5, /* 143 */ 2, /* 144 */
      3, /* 145 */ 3, /* 146 */ 4, /* 147 */ 3, /* 148 */ 4, /* 149 */
      4, /* 150 */ 5, /* 151 */ 3, /* 152 */ 4, /* 153 */ 4, /* 154 */
      5, /* 155 */ 4, /* 156 */ 5, /* 157 */ 5, /* 158 */ 6, /* 159 */
      2, /* 160 */ 3, /* 161 */ 3, /* 162 */ 4, /* 163 */ 3, /* 164 */
      4, /* 165 */ 4, /* 166 */ 5, /* 167 */ 3, /* 168 */ 4, /* 169 */
      4, /* 170 */ 5, /* 171 */ 4, /* 172 */ 5, /* 173 */ 5, /* 174 */
      6, /* 175 */ 3, /* 176 */ 4, /* 177 */ 4, /* 178 */ 5, /* 179 */
      4, /* 180 */ 5, /* 181 */ 5, /* 182 */ 6, /* 183 */ 4, /* 184 */
      5, /* 185 */ 5, /* 186 */ 6, /* 187 */ 5, /* 188 */ 6, /* 189 */
      6, /* 190 */ 7, /* 191 */ 2, /* 192 */ 3, /* 193 */ 3, /* 194 */
      4, /* 195 */ 3, /* 196 */ 4, /* 197 */ 4, /* 198 */ 5, /* 199 */
      3, /* 200 */ 4, /* 201 */ 4, /* 202 */ 5, /* 203 */ 4, /* 204 */
      5, /* 205 */ 5, /* 206 */ 6, /* 207 */ 3, /* 208 */ 4, /* 209 */
      4, /* 210 */ 5, /* 211 */ 4, /* 212 */ 5, /* 213 */ 5, /* 214 */
      6, /* 215 */ 4, /* 216 */ 5, /* 217 */ 5, /* 218 */ 6, /* 219 */
      5, /* 220 */ 6, /* 221 */ 6, /* 222 */ 7, /* 223 */ 3, /* 224 */
      4, /* 225 */ 4, /* 226 */ 5, /* 227 */ 4, /* 228 */ 5, /* 229 */
      5, /* 230 */ 6, /* 231 */ 4, /* 232 */ 5, /* 233 */ 5, /* 234 */
      6, /* 235 */ 5, /* 236 */ 6, /* 237 */ 6, /* 238 */ 7, /* 239 */
      4, /* 240 */ 5, /* 241 */ 5, /* 242 */ 6, /* 243 */ 5, /* 244 */
      6, /* 245 */ 6, /* 246 */ 7, /* 247 */ 5, /* 248 */ 6, /* 249 */
      6, /* 250 */ 7, /* 251 */ 6, /* 252 */ 7, /* 253 */ 7, /* 254 */
      8  /* 255 */
       };


template <size_t N, typename T> 
class BitsetImpl1
  {
  T   data;
  public:
    typedef T index_type;

    BitsetImpl1() : data(0) {}

    void set(T n)
      {
      data |= (1 << n);
      }

    void clear(T n)
      {
      data &= ~(1 << n);
      }


    size_t size() const
      {
      return N;
      }

    size_t count() const
      {
      size_t res = 0;
      
      for(size_t i = 0; i < sizeof(data); i++)
        {
        res += bit_count[*(reinterpret_cast<const unsigned char *>(&data)+i)];
        }
      return res;
      }

    bool test(size_t n) const
      {
      return (data & (1 << n)) != 0;
      }

    bool none() const
      {
      return data == 0;
      }

    bool any() const
      {
      return data != 0;
      }

    bool operator==(const BitsetImpl1<N,T> &rhs) const
      {
      return data == rhs.data;
      }

    void operator&=(const BitsetImpl1<N,T> &rhs) 
      {
      data &= rhs.data;      
      }

    void operator^=(const BitsetImpl1<N,T> &rhs) 
      {
      data ^= rhs.data;      
      }

    size_t hashValue(size_t index) const
      {
      return HashFunction(index, data, N);
      }
  };

template <size_t N, size_t W> 
class BitsetImpl2
  {
  unsigned long data[W];

  enum {BITS_PER_WORD = CHAR_BIT*sizeof(unsigned long)};

  // Return index of word which holds bit pos
  inline static size_t wordindex(size_t pos)
  {
    return pos/BITS_PER_WORD;
  }

  // Return the bit position within the word, 
  // which holds bit pos
  inline static size_t wordpos(size_t pos) 
  {
    return pos - (pos/BITS_PER_WORD) * BITS_PER_WORD;
  }
    inline static unsigned long wordmask(size_t pos)
    {
      return static_cast<unsigned long >(1) << wordpos(pos);
    }

  inline unsigned long word(size_t pos) const
    {
      return data[wordindex(pos)];
    }

  inline unsigned long &word(size_t pos) 
    {
      return data[wordindex(pos)];
    }

  public:
    typedef unsigned long index_type;

    BitsetImpl2() 
      {
      std::fill_n(data, W, 0);
      }

    void set(index_type n)
      {
      word(n) |= wordmask(n);
      }

    void clear(index_type n)
      {
      word(n) &= ~wordmask(n);
      }


    size_t size() const
      {
      return N;
      }

    size_t count() const
      {
      size_t res = 0;
      
      for(size_t i = 0; i < sizeof(data); i++)
        {
        res += bit_count[*(reinterpret_cast<const unsigned char *>(&data)+i)];
        }
      return res;
      }

    bool test(size_t n) const
      {
      return (word(n) & wordmask(n)) != 0;
      }

    bool none() const
      {
      return !any();
      }

    bool any() const
      {
      for(size_t i = 0; i < W; i++)
        if (data[i])
          return true;
      return false;
      }

    bool operator==(const BitsetImpl2<N,W> &rhs) const
      {
      for(size_t i = 0; i < W; ++i)
        {
        if (data[i] != rhs.data[i])
          return false;
        }
      return true;
      }

    void operator&=(const BitsetImpl2<N,W> &rhs) 
      {
      for (size_t i = 0; i < W; i++)
        data[i] &= rhs.data[i];
      }

    void operator^=(const BitsetImpl2<N,W> &rhs) 
      {
      for (size_t i = 0; i < W; i++)
        data[i] ^= rhs.data[i];
      }

    size_t hashValue(size_t index) const
      {
      size_t hv = 0;
      for (size_t i = 0; i < W; i++)
        hv ^= HashFunction(index+i, data[i], 32); 
      return hv;
      }
  };

template <size_t N>
struct NewBitset
  {
  };

// Specialised version for 8,16 & 32 bit
template<>
struct NewBitset<8> : public BitsetImpl1<8,unsigned char>
  {
  };

template<>
struct NewBitset<16> : public BitsetImpl1<16,unsigned short>
  {
  };

template<>
struct NewBitset<32> : public BitsetImpl1<32,unsigned long>
  {
  };

template<>
struct NewBitset<64> : public BitsetImpl2<64,2>
  {
  };

template<>
struct NewBitset<128> : public BitsetImpl2<128,4>
  {
  };

template<>
struct NewBitset<256> : public BitsetImpl2<256,8>
  {
  };

#endif
