/*
 * Copyright (C) 2003 Jeppe Nejsum Madsen, nejsum@diku.dk
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef RUNTIME_NETWORK_HPP
#define RUNTIME_NETWORK_HPP

#include "csplib/constraint_network.hpp"
#include "csplib/graph.hpp"

class RuntimeNetwork :   public ConstraintNetwork
  {
  dualgraph_t                             jointree;
  std::vector<std::pair<size_t, size_t> > H;

  // Initial values used for reset
  std::vector< std::vector<bool>  >       tsv;

  relcol_t                                initrels;
  
  void          update_valid_domains();
  bool          arc_consistency();
  bool          arc_consistency(Relation *rel);
  bool          revise_dual(size_t var_index, size_t domain_index);
  void          propagate(relset_t Q);
  bool          special_revise(Relation &r, Relation &);
  bool          revise(Relation &r, Relation &s);


  Last  last, initial_last;
  bool  compressed, maxweight_is_1;

  public:
    RuntimeNetwork();

    void reset();

    bool add_constraint(size_t varid, size_t domain_index);
    void remove_constraint(size_t varid);
  };

#endif
