#include "csplib/column.hpp"
#include "csplib/variable.hpp"
#include "csplib/relation.hpp"
#include "csplib/detail/column_impl.hpp"
#include "csplib/constraint_network.hpp"

extern void addDigitCol(Relation &r, Variable &var, std::string s);

class TestSetup : public CppUnit::TestFixture 
  {
  protected:
    static int const domainSize[];
    static const int numDomains; 
    int              numVars;

    LinkVariable  **vars;
    ConstraintNetwork instance;

  public:
    TestSetup(int num) : numVars(num) {}

    Relation *addBinRel(size_t id, char *name, Variable *v1, Variable *v2, char *col1, char *col2);
    void addDigitCol(Relation &r, Variable &var, std::string s);
    void assertRelsEqual(Relation &r, Relation &s);
    void setUp();
    void tearDown();
  };