#include "stdafx.h"
#include "test.hpp"

class CompressTest : public TestSetup
  {
  CPPUNIT_TEST_SUITE( CompressTest );
  CPPUNIT_TEST( testComp );
  CPPUNIT_TEST_SUITE_END();

  public:
    CompressTest()
      : TestSetup(3) {}

    void testComp()
      {                         
      for(int i = 0; i < numDomains; i++)
        {
        Relation rel(1, "exp");
        Variable *a = *(vars + i);
        Variable *b = *(vars + i + numDomains);
        Variable *c = *(vars + i + numDomains * 2);
        addDigitCol(rel, *a, "22334455");
        addDigitCol(rel, *b, "12120101");
        addDigitCol(rel, *c, "44445555");

        std::stringstream s1, s2;
        s1 << rel;
        rel.compress();
        rel.uncompress();
        s2 << rel;
        CPPUNIT_ASSERT(s1.str() == s2.str());
        }
      }
  };

CPPUNIT_TEST_SUITE_REGISTRATION( CompressTest );
