#include "stdafx.h"
#include "test.hpp"
#include "csplib/graph.hpp"
#include <boost/graph/graphviz.hpp>

using namespace boost;

class GraphTest : public TestSetup
  {
  CPPUNIT_TEST_SUITE( GraphTest );
  CPPUNIT_TEST(testGraph1);
  //CPPUNIT_TEST(testGraph2);
  CPPUNIT_TEST_SUITE_END();
  public:

    GraphTest() : TestSetup(5) {}

    void testGraph1()
      {
      Variable  *a = *(vars);
      Variable  *b = *(vars+numDomains);
      Variable  *c = *(vars+numDomains*2);
      Variable  *d = *(vars+numDomains*3);
      Variable  *e = *(vars+numDomains*4);

      addBinRel(0, "ab", a,b,"0","0");
      addBinRel(1, "bc", a, b,"0","0");
      addBinRel(2, "ce", c,e,"0","0");
      addBinRel(3, "bd", b,d,"0","0");

      dualgraph_t g;
      createDualGraph(instance, g);
      std::ofstream f("graph.dot");

      property_map<dualgraph_t, vertex_name_t>::type vertex_map = get(vertex_name, g);
      property_map<dualgraph_t, edge_name_t>::type edge_map = get(edge_name, g);
      write_graphviz(f, g, make_label_writer(vertex_map), make_label_writer(edge_map));
      }
  };

CPPUNIT_TEST_SUITE_REGISTRATION( GraphTest );
