#include "stdafx.h"
#include "test.hpp"

class RelationTest : public TestSetup
  {
  CPPUNIT_TEST_SUITE( RelationTest );
  CPPUNIT_TEST(testRedundantTuples);
 // CPPUNIT_TEST(testNormalize2);
  //CPPUNIT_TEST(testNormalize3);
  CPPUNIT_TEST_SUITE_END();
  public:
    RelationTest() : TestSetup(4) {}

    void testRedundantTuples()
      {
      for(int i = 0; i < numDomains; i++)
        {
        Variable  *a = *(vars+numDomains*0+i);
        Variable  *b = *(vars+numDomains*1+i);
        Variable  *c = *(vars+numDomains*2+i);

        varset_t  vars;
        vars.insert(b);
        vars.insert(c);

        Relation rel1(0, "rel1");
        addDigitCol(rel1, *a, "1111222");
        addDigitCol(rel1, *b, "0011011");
        addDigitCol(rel1, *c, "0101101");


        Relation rel2(0, "rel1");
        addDigitCol(rel2, *a, "1111222");
        addDigitCol(rel2, *b, "0011011");
        addDigitCol(rel2, *c, "0101101");

        rel2.compress(&vars);
        rel1.compress(&vars);

        rel2.uncompress();

        std::auto_ptr<Relation> proj1 = rel1.project(vars,42);
        std::auto_ptr<Relation> proj2 = rel2.project(vars,42);

        rel_tuples(std::cout, *proj1);
        proj1->removeRedundancy();
        rel_tuples(std::cout, *proj1);
        //std::cout << *proj1 << std::flush;
        //std::cout << " Redundant=" << proj1->getNumRedundantTuples() << "\n";
        //std::cout << *proj2 << " Redundant=" << proj2->getNumRedundantTuples() << "\n";
        }
      }


  /*
    void testNormalize1()
      {
      for(int i = 0; i < numDomains; i++)
        {
        Variable  *a = *(vars+numDomains*0+i);
        Variable  *b = *(vars+numDomains*1+i);
        Variable  *c = *(vars+numDomains*2+i);

        varset_t  vars;
        vars.insert(b);
        vars.insert(c);

        Relation rel1(0, "rel1");
        addDigitCol(rel1, *a, "1111222");
        addDigitCol(rel1, *b, "0011011");
        addDigitCol(rel1, *c, "0101101");


        Relation rel2(0, "rel1");
        addDigitCol(rel2, *a, "1111222");
        addDigitCol(rel2, *b, "0011011");
        addDigitCol(rel2, *c, "0101101");

        assertRelsEqual(rel1, rel2);
        CPPUNIT_ASSERT(rel1.normalize() == false);

        rel2.compress(&vars);
        rel1.compress(&vars);
        CPPUNIT_ASSERT(rel2.normalize() == false);
        assertRelsEqual(rel1, rel2);

        rel2.uncompress();

        std::auto_ptr<Relation> proj1 = rel1.project(vars,42);
        std::auto_ptr<Relation> proj2 = rel1.project(vars,42);
        proj1->normalize();
        proj1->uncompress();

        proj2->uncompress();
        proj2->compress();
        proj2->uncompress();
        assertRelsEqual(*proj1, *proj2);
        }
      }

    void testNormalize2()
      {
      for(int i = 0; i < numDomains; i++)
        {
        Variable  *a = *(vars+numDomains*0+i);
        Variable  *b = *(vars+numDomains*1+i);
        Variable  *c = *(vars+numDomains*2+i);

        varset_t  vars;
        vars.insert(b);
        vars.insert(c);

        Relation rel1(0, "rel1");
        addDigitCol(rel1, *a, "12222");
        addDigitCol(rel1, *b, "00101");
        addDigitCol(rel1, *c, "00011");


        Relation rel2(0, "rel1");
        addDigitCol(rel2, *a, "12222");
        addDigitCol(rel2, *b, "00101");
        addDigitCol(rel2, *c, "00011");

        rel1.compress(&vars);
        
        std::auto_ptr<Relation> proj1 = rel1.project(vars,42);
        std::auto_ptr<Relation> proj2 = rel2.project(vars,42);
        proj1->normalize();
        proj2->compress();
        
        std::cout << rel1 << *proj1 << *proj2;

        proj1->uncompress();
        proj1->compress();
        proj1->uncompress();

        proj2->uncompress();
        assertRelsEqual(*proj1, *proj2);
        }
      }
      */
  };

CPPUNIT_TEST_SUITE_REGISTRATION( RelationTest );